import java.util.*;
public class KonohaTraining {

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int cases = in.nextInt();
        long x2,x3,x4,y2,y3,y4,m1,m2,b2,x,y;
        
        
        while(cases-- > 0){
            x3 = in.nextLong();
            y3 = in.nextLong();
            x4 = in.nextLong();
            y4 = in.nextLong();
            x2 = in.nextLong();
            y2 = in.nextLong();
            if (intersect(0, 0, x2, y2, x3, y3, x4, y4))
                System.out.println("NO");
            else
                System.out.println("YES");
        }
    
    }
    

public static long cross_product(long ax, long ay, 
                        long bx, long by, 
                        long cx, long cy)
{
    return (bx - ax) * (cy - ay) - (by - ay) * (cx - ax);
}

public static boolean inside(long ax, long ay, 
            long bx, long by, 
            long cx, long cy)
{
    return (Math.min(ax,bx)<=cx && cx<=Math.max(ax,bx) && 
            Math.min(ay,by)<=cy && cy<=Math.max(ay,by));
}

public static boolean intersect (long ax, long ay, 
                long bx, long by, 
                long cx, long cy, 
                long dx, long dy) 
{
    long abc=cross_product(ax, ay, bx, by, cx, cy);
    long abd=cross_product(ax, ay, bx, by, dx, dy);
    long cda=cross_product(cx, cy, dx, dy, ax, ay);
    long cdb=cross_product(cx, cy, dx, dy, bx, by);

    if (((abc>0 && abd<0)||(abc<0 && abd>0)) &&
        ((cda>0 && cdb<0)||(cda<0 && cdb>0)))
        return true;

    if (abc == 0 && inside(ax, ay, bx, by, cx, cy))return true;
    if (abd == 0 && inside(ax, ay, bx, by, dx, dy))return true;
    if (cda == 0 && inside(cx, cy, dx, dy, ax, ay))return true;
    return cdb == 0 && inside(cx, cy, dx, dy, bx, by);
}
}