#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * __builtin_popcountll(long long d)
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//

int digit[11];
 
long tobin(string s){
//	for (int i = 0; i < s.size(); ++i) {
//		s[i] = (s[i] == 'Y' ? '1' : '0');
//	}
	return strtol(s.c_str(), NULL, 2);
}


int main(){
	FASTER;
	digit[0] = strtol("1111110", NULL, 2);
	digit[1] = strtol("0110000", NULL, 2);
	digit[2] = strtol("1101101", NULL, 2);
	digit[3] = strtol("1111001", NULL, 2);
	digit[4] = strtol("0110011", NULL, 2);
	digit[5] = strtol("1011011", NULL, 2);
	digit[6] = strtol("1011111", NULL, 2);
	digit[7] = strtol("1110000", NULL, 2);
	digit[8] = strtol("1111111", NULL, 2);
	digit[9] = strtol("1111011", NULL, 2);


	int n;
	while(cin >> n, n){


		vi in;
		for (int i = 0; i < n; ++i) {
			string s;cin >> s;
			in.push_back(tobin(s));
//			printf("in = %d\n", in[i]);
		}

		bool match = false;
		for (int i = 9; i >= n-1; --i) {
//			printf("i = %d\n", i);
			int broken = 0;
			match = true;
			for (int j = 0; j < n; ++j) {
				int m = i - j;
//				printf("\tm = %d\n", m);
				if((broken & in[j]) ){
					match = false;
					break;
				}

				if( (in[j] |  digit[m]) == digit[m]){
					broken |= (in[j] ^  digit[m]);
				}else{
					match = false;
				}
			}
			if(match)break;
		}

		if(match)cout << "MATCH\n";
		else cout << "MISMATCH\n";
	}

	return 0;
}
