/* package whatever; // don't place package name! */

import java.util.*;
import java.lang.*;
import java.io.*;

public class Puzzle{
	public static void main(String args[]) {
		Scanner sc = new Scanner(System.in);
		int t = sc.nextInt();
		while (t-- > 0) {
	        int N1 = sc.nextInt();
	        int M1 = sc.nextInt();
	        String[] B = new String[N1];
	        for (int i = 0; i < N1; ++i) 
	            B[i] = sc.next();
	 
	        int N2 = sc.nextInt();
	        int M2 = sc.nextInt();
	        String[] P = new String[N2];
	        for (int i = 0; i < N2; ++i) 
	            P[i] = sc.next();
	        
	        int R1, C1;
	        R1 = C1 = 100000000;
	        for (int i = 0; i < N1; ++i) 
	            for (int j = 0; j < M1; ++j) 
	                if(B[i].charAt(j) == '.'){
	                    R1 = Math.min(R1, i);
	                    C1 = Math.min(C1, j);
	                }
	        
	        Boolean ok = true;
	        for (int i = 0; i < N1; ++i)
	            for (int j = 0; j < M1; ++j)
	                if(B[i].charAt(j) == '.')
	                    if(i >= N2 + R1 || j >= M2 + C1)
	                    	ok = false;
	                    
            for (int i = 0; i < N2; ++i) 
	            for (int j = 0; j < M2; ++j) 
	                if(i+R1 >= N1 || j+C1 >= M1 || P[i].charAt(j) == B[i+R1].charAt(j+C1))
	                    ok = false;
	        
            System.out.println(ok ? "Yes" : "No");
		}
	}
}