#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//
#define MAXSZ 13
int dp[1 << MAXSZ];
int vis[1 << MAXSZ];
int n;
int P[MAXSZ];
int C[MAXSZ][MAXSZ];

int f(int b){
	int &ret = dp[b];
	if(b == (1<<n)-1)return ret = 0;
	if(!vis[b]){
		vis[b] = 1;
		ret = -1e9;

		for (int i = 0; i < n; ++i) {
			for (int j = i+1; j < n; ++j) {
				for (int k = j+1; k < n; ++k) {

					if((b & (1<<i) ) || (b &(1<<j) ) || (b &(1<<k)) )continue;
					int lev = C[i][j] + C[i][k] + C[j][k];
					int t = f(b | (1<< i) | (1 << j) | (1 << k)) + lev;

					if(t > ret){
						ret = t;
					}
				}
			}
		}
	}

	return ret;
}

int main(){
	FASTER;

	int t;
	cin >> t;
	while(t--){
		cin >> n;
		int sum = 0;
		for (int i = 0; i < n; ++i) {
			cin >> P[i];
			sum += P[i];
		}
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				cin >> C[i][j];

		MEM(vis,0);
		MEM(dp,-1);
		int best = f(0);

		cout << best + sum << endl;

	}

	return 0;
}
