#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef pair<string, string> ss;
typedef pair<string, ss> sss;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<int> vi;

int main() {
    int cases, N;
    cin >> cases;
    while(cases--){
        cin >> N;
        map<string, int> maps;
        sss holder[N-1];
        for(int i = 0; i < N-1; i++){
            string a, b, c;
            cin >> a >> b >> c;
            holder[i] = sss(a, ss(b, c));
            maps[holder[i].first] = i;
        }

        //adding marg husband to the hashmap
        maps[holder[0].second.first] = N-1;
        vector<vi> graph(N+1, vi());
        vi ans(N, 0);
        graph[0].push_back(maps[holder[0].second.second]);
        for (int i = 1; i < N-1; i++){
            graph[i].push_back(maps[holder[i].second.first]);
            graph[i].push_back(maps[holder[i].second.second]);
        }
        int Dest = N-1;
    
        vi distance(N+1, 100000000);
        vi visited(N+1, 0);
        distance[0] = 0;
        for (int i = 0; i < N + 1; i++){
            int min = 100000000;
            int index = 0;
            for(int j = 1; j < N + 1; j++)
                if (!visited[j] && distance[j] < min){
                    min = distance[j];
                    index = j;
                }
            visited[index] = 1;
            for (int k = 0; k < graph[index].size(); k++)
                if (!visited[graph[index][k]] && distance[index] + 1 < distance[graph[index][k]])
                    distance[graph[index][k]] = distance[index] + 1;
        }
        for (int i = 1; i < N; i++){
            if (distance[i] == 100000000){
                ans[i] = -1;
            }
            else
                if (i != 0)
                    ans[i]=distance[i];
        }
        int sol = ans[N-1];
        if (sol!= -1)
            sol--;
        cout << sol << endl;
    }
}
