#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//


int main(){
	FASTER;

	int t;
	cin >> t;
	while(t--){

		int N1,M1,N2,M2;

		cin >> N1 >> M1;
		vector<string> B(N1,"");
		for (int i = 0; i < N1; ++i)
			cin >> B[i];

		cin >>  N2 >> M2;
		vector<string> P(N2,"");
		for (int i = 0; i < N2; ++i)
			cin >> P[i];


		int R1,C1,R2,C2;
		R1 = C1 = 100000000;
		R2 = C2 = 0;

		for (int i = 0; i < N2; ++i) {
			for (int j = 0; j < M2; ++j) {
				if(P[i][j] == 'X'){
					R1 = min(R1, i);
					C1 = min(C1, j);
					R2 = max(R2, i);
					C2 = max(C2, j);
				}
			}
		}

		vector<string> Pt;
		for (int i = R1; i <= R2; ++i) {
			Pt.push_back(P[i].substr(C1, C2 - C1 + 1));
		}
		P = Pt;

		N2 = P.size();
		M2 = P[0].size();

		R1 = C1 = 100000000;
		for (int i = 0; i < N1; ++i) {
			for (int j = 0; j < M1; ++j) {
				if(B[i][j] == '.'){
					R1 = min(R1, i);
					C1 = min(C1, j);
				}
			}
		}

		bool ok = true;

		if(R1 == 100000000){
			if(R2 == 100000000) cout << "Yes\n";
			else cout << "No\n";
			continue;
		}

		for (int i = 0; i < N1; ++i)
			for (int j = 0; j < M1; ++j)
				if(B[i][j] == '.')
					if(i >= N2 + R1 || j >= M2 + C1)
						ok = false;

		if(R1 + N2 > N1  || C1 + M2 > M1)ok = false;

		for (int i = 0; i < N2; ++i) {
			for (int j = 0; j < M2; ++j) {
				if(i+R1 >= N1 || j+C1 >= M1 || P[i][j] == B[i+R1][j+C1]){
					ok = false;
				}
			}
		}


		cout << (ok ? "Yes" : "No") << endl;
	}

	return 0;

}
