import java.util.*;

public class Detective {
    static int[] ans;
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int cases = in.nextInt();
        while(cases-->0){
        int N = in.nextInt();
        Map<String, Integer> maps = new HashMap<>();
        event[] holder = new event[N-1];
        for(int i = 0; i < N-1; i++){
            holder[i] = new event(in.next(), in.next(), in.next());
            //creating hash map
            maps.put(holder[i].p, i);
        }
        //adding marg husband to the hashmap
        maps.put(holder[0].a, N-1);
        ArrayList<Vertex> graph[] = new ArrayList[N+1];
        ans = new int[N];
        graph[0] = new ArrayList<Vertex>();
        graph[0].add(new Vertex(maps.get(holder[0].b)));
        for (int i = 1; i < N-1; i++){
            if(graph[i] == null)
                graph[i] = new ArrayList<Vertex>();
            graph[i].add(new Vertex(maps.get(holder[i].a)));
            graph[i].add(new Vertex(maps.get(holder[i].b)));
        }
        int Dest = N-1;
        Dijkstra(graph, 0, N);
        int sol = ans[N-1];
        if (sol!= -1)
            sol --;
        System.out.println(sol);        
    }}
    
    static void Dijkstra(ArrayList<Vertex>[] graph, int S, int numV){
        int distance[] = new int[numV + 1];
        boolean visited[] = new boolean[numV + 1];
        
        for (int i = 0; i < numV + 1; i++)
            distance[i] = Integer.MAX_VALUE;
        distance[S] = 0;
        for (int i = 0; i < numV + 1; i++){
            int min = Integer.MAX_VALUE;
            int index = 0;
            for(int j = 1; j < numV + 1; j++)
                if (!visited[j] && distance[j] < min){
                    min = distance[j];
                    index = j;
                }
            visited[index] = true;
            if (graph[index] != null){
                for (int k = 0; k < graph[index].size(); k++){
                    if (!visited[graph[index].get(k).key] && distance[index] + graph[index].get(k).Weigth < distance[graph[index].get(k).key]){
                        distance[graph[index].get(k).key] = distance[index] + graph[index].get(k).Weigth;
                    }
                }
            }
        }
        for (int i = 1; i < numV; i++){
            if (distance[i] == Integer.MAX_VALUE){
                ans[i] = -1;
            }
            else
                if (i != S)
                    ans[i]=distance[i];
        }
    }
    
    static class Vertex{
        //fields;
        int key;
        int Weigth;
        //constructor

        public Vertex(int key) {
            this.key = key;
            this.Weigth = 1;
        }
    }

}
class event{
    //field
    String p;
    String a;
    String b;

    public event(String p, String a, String b) {
        this.p = p;
        this.a = a;
        this.b = b;
    }
    
}