
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * __builtin_popcountll(long long d)
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//

int main(){
	FASTER;

	int i, j;
	int s, n;
	double pi;

	while (cin >> n,n) {
		s = 0;
		int a[n];

		for (i = 0; i < n; i++) cin >> a[i];

		for (i = 0; i < n; i++) for (j = i + 1; j < n; j++) if (gcd(a[i], a[j]) == 1) s++;

		//printf("s = %d\n", s);

		if (s) {
			pi = sqrt(3.0 * n * (n - 1.0) / s);
			printf("%.6lf\n", pi);
		} else {
			printf("No estimate for this data set.\n");
		}
	}

	return 0;
}
