import java.util.ArrayList;
import java.util.Scanner;


public class EstimatingPI {

	int gcd(int a, int b){
		if(b == 0)return a;
		return gcd(b, a % b);
	}
	
	void solve(){
		Scanner in = new Scanner(System.in);
		
		while(in.hasNext()){
			int n = in.nextInt();
			
			if(n == 0)break;
			
			ArrayList<Integer> arr = new ArrayList<Integer>();
			
			for(int i = 0 ; i < n ; i++){
				arr.add(in.nextInt());
			}
			
			int x = 0;
			
			for (int i = 0; i < n; i++) 
				for (int j =i+1; j < n; j++) 
					if(gcd(arr.get(i), arr.get(j)) == 1)x++;
			
			if(x > 0){
			
				double a = Math.sqrt(3.0 * n * ( n -1) / x);
				System.out.printf("%.6f\n",a);
			}else{
				System.out.println("No estimate for this data set.");
			}
		}
			
			
		
		in.close();
	}
	
	public static void main(String[] args) {
		
		(new EstimatingPI()).solve();
	}
}
