#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * __builtin_popcountll(long long d)
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//
vector<string> M;
int N = 12;

int area;

void solve(){
	int temp = 0;
	for (int p1 = 1; p1 < N - 1; ++p1) {
		for (int p2 = p1+2; p2 < N-1; ++p2) {
			for (int p3 = 1; p3 < N-1; ++p3) {
				if(M[0][p1] == M[2][p3]){
					for (int p4 = 1; p4 < N-1; ++p4) {
						if(M[0][p2] == M[3][p4]){
							int d = p2 - p1;
							for (int p5 = 0; p5 < N-1; ++p5) {
								int id1 = p5 + p3 + 2;
								int id2 = p5 + p4 + 2;

								if(id1 >= M[2].size()-1)continue;
								if(id2 >= M[3].size()-1)continue;

								for (int p6 = 1; p6 < N-1 - d; ++p6) {

									if(M[1][p6] == M[2][id1] && M[1][p6 + d] == M[3][id2]){
										int tmp = (d - 1)*( p5 + 1);

										area = max(area, tmp);
									}
								}
							}
						}
					}
				}
			}
		}

	}

}

int main(){
	FASTER;

	string s;

	while(cin >> s, s != "Q"){
		M.clear();
		M.push_back(s);
		for (int i = 0; i < 3; ++i) {
			cin >> s;
			M.push_back(s);
		}


		area = 0;
		sort(M.begin(), M.end());
		do{
			solve();
		}while(next_permutation(M.begin(), M.end()));


		cout << area << endl;

	}


	return 0;
}
