#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<int,int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * __builtin_popcountll(long long d)
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//

int main(){
	FASTER;

	int n;
	int N = 0;
	while(cin >> n, n){
		vi s;
		s.push_back(n);
		N = 1;
		while(cin >> n , n) s.push_back(n), N++;

		int l = 1;
		int up = 0, down = 0;
		int cnt_up = 0, cnt_down = 0;
		int dir = 0;
		for (int i = 1; i < s.size(); ++i) {

			if(dir != 2 && s[i] > s[i-1]){

				if(dir == 1){
					down += l;
					cnt_down++;
				}
				if(dir != 0)
					l = 1;
				dir = 2;

			}else if(dir != 1 && s[i] < s[i-1]){
				if(dir == 2){
					up += l;
					cnt_up++;
				}
				if(dir != 0)
					l = 1;
				dir = 1;
			}else{
				l++;
			}


		}

		if(dir == 1){
			down += l;
			cnt_down++;
		}
		if(dir == 2){
			up += l;
			cnt_up++;
		}


		printf("Nr values = %d:  %.2lf %.2lf\n", N,cnt_up ? up * 1.0 / cnt_up : 0.0,
				cnt_down ? down * 1.0 / cnt_down : 0.0);

	}


	return 0;
}
