#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

#define MEM(arr,val)memset((arr),(val), sizeof (arr))
#define PI (acos(0)*2.0)
#define FASTER ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL)

typedef long long ll;
typedef pair<ll,ll> ii;
typedef vector<int> vi;
typedef vector<ii> vii;

ll gcd(ll a,ll b){return b == 0 ? a : gcd(b,a%b);}
ll lcm(ll a,ll b){return a*(b/gcd(a,b));}

/**
 * __builtin_popcount(int d) // count bits
 * strtol(s, &end, base); // convert base number
 */
//----------------------------------------------------------------------//
ll X1,Y1,X2,Y2;
void out(int shiftx, int shifty){
	cout << X1 + shiftx << " " << Y1 + shifty << endl;
}
int main(){
	FASTER;

	int T;
	cin >> T;

	while(T--){

		cin >> X1 >> Y1 >> X2 >> Y2;

		ll d1,d2;
		d1 = (X2 - X1 + Y2 - Y1) / 2;
		d2 = (X2 - X1 + Y1 - Y2) / 2;

		ii i1(X1+d1,Y1+d1);
		ii i2(X1+d2,Y1-d2);
		if(i1 > i2){

			if(i2.first >= 0 && i2.second >= 0)
				cout << i2.first << " " << i2.second <<" ";
			if(i1.first >= 0 && i1.second >= 0)
				cout << i1.first << " " << i1.second;

		}else{
			if(i1.first >= 0 && i1.second >= 0)
				cout << i1.first << " " << i1.second <<" ";
			if(i2.first >= 0 && i2.second >= 0)
				cout << i2.first << " " << i2.second;
		}

		cout << endl;
	}


	return 0;
}
